'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.isSubset = isSubset;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _es6Map = require('es6-map');

var _es6Map2 = _interopRequireDefault(_es6Map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isSubset(small, large) {
  if (!_underscore2.default.isArray(small) || !_underscore2.default.isArray(large)) {
    return false;
  }

  if (small.length > large.length) {
    return false;
  }

  for (var index = 0; index < small.length; index++) {
    if (small[index] !== large[index]) {
      return false;
    }
  }

  return true;
}

function constructCache(seedObj, predicate) {
  var cache = new _es6Map2.default();

  function recurse(obj) {
    var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

    var k = predicate(obj);

    if (k) {
      cache.set(path, k);
    }

    if (_underscore2.default.isObject(obj)) {
      _underscore2.default.each(obj, function (value, key) {
        recurse(value, [].concat((0, _toConsumableArray3.default)(path), [key]));
      });
    }
  }

  recurse(seedObj);

  return cache;
}

var ObjectCache = function () {
  function ObjectCache(seedObj, predicate) {
    (0, _classCallCheck3.default)(this, ObjectCache);

    if (seedObj instanceof _es6Map2.default) {
      this.cache = seedObj;
    } else if (_underscore2.default.isObject(seedObj) && _underscore2.default.isFunction(predicate)) {
      this.cache = constructCache(seedObj, predicate);
    } else {
      this.cache = new _es6Map2.default();
    }
    this.getCacheForValue = this.getCacheForValue.bind(this);
    this.getCacheForPath = this.getCacheForPath.bind(this);
    this.getPaths = this.getPaths.bind(this);
    this.getValues = this.getValues.bind(this);
  }

  /**
   * Returns a subset of the cache graph filtered to only include the values equal to the query
   * @param query
   * @returns ObjectCache
   */


  (0, _createClass3.default)(ObjectCache, [{
    key: 'getCacheForValue',
    value: function getCacheForValue(query) {
      var map = new _es6Map2.default();
      this.cache.forEach(function (value, path) {
        if (_underscore2.default.isEqual(query, value)) {
          map.set(path, value);
        }
      });

      return new ObjectCache(map);
    }

    /**
     * Returns a subset of the cache graph localized for the given path
     * @param currentPath
     * @returns ObjectCache
     */

  }, {
    key: 'getCacheForPath',
    value: function getCacheForPath(currentPath) {
      if (currentPath.length === 0) {
        return this;
      }

      var subset = _underscore2.default.partial(isSubset, currentPath);
      var relativePath = _underscore2.default.partial(_underscore2.default.drop, _underscore2.default, currentPath.length);
      var map = new _es6Map2.default();

      this.cache.forEach(function (value, path) {
        if (subset(path)) {
          map.set(relativePath(path), value);
        }
      });

      return new ObjectCache(map);
    }
  }, {
    key: 'getPaths',
    value: function getPaths() {
      return (0, _from2.default)(this.cache.keys());
    }
  }, {
    key: 'getValues',
    value: function getValues() {
      return (0, _from2.default)(this.cache.values());
    }
  }]);
  return ObjectCache;
}();

exports.default = ObjectCache;